<template>
    <div id="user-profile">
        <div id="nav">
            <router-link to="/" tag="a">Back to all users</router-link>
        </div>

        <span v-if="loggedUser.email != other_user.email">Logged in as {{loggedUser.first_name}} {{loggedUser.last_name}} ({{loggedUser.email}})</span>
        <span v-if="loggedUser.email == other_user.email">This is your profile</span>
        <h1 v-if="loggedUser.email != other_user.email">User #{{$route.params.user_id}}</h1> 

        <h3 v-if="loggedUser.email != other_user.email" class='float-left'>Viewing {{other_user.first_name}} {{other_user.last_name}} ({{other_user.email}})</h3>
        
        <div v-if="loggedUser.email == other_user.email">
            <div class="input-group input-group-sm mb-3">
                <div class="input-group-prepend">
                    <span class="input-group-text" id="inputGroup-sizing-sm">First Name</span>
                </div>
                <input type="text" class="form-control" aria-label="First Name" aria-describedby="inputGroup-sizing-sm" :value="other_user.first_name">
            </div>

            <div class="input-group input-group-sm mb-3">
                <div class="input-group-prepend">
                    <span class="input-group-text" id="inputGroup-sizing-sm">Last Name</span>
                </div>
                <input type="text" class="form-control" aria-label="Last Name" aria-describedby="inputGroup-sizing-sm" :value="other_user.last_name">
            </div>
        </div>

        <table class="table table-striped">
            <thead>
                <tr>
                <th>#</th>
                <th>Detailed Address</th>
                <th>City</th>
                <th>Province</th>
                <th>Country</th>
                <th>Postal Code</th>
                <th>Actions</th>
                </tr>
            </thead>
            <tbody>
                <tr v-for="(address, index) in other_user_addresses" :key="index">
                    <th scope="row">{{index + 1}}</th>
                    <td>{{ address.address }}</td>
                    <td>{{ address.city }}</td>
                    <td>{{ address.province }}</td>
                    <td>{{ address.country }}</td>
                    <td>{{ address.postal_code }}</td>
                    <td><button type="button" class="btn btn-primary" data-toggle="modal" data-target="#exampleModal" data-whatever="@mdo">Edit</button></td>
                </tr>
            </tbody>
        </table>
        <h4 v-if="other_user_addresses.length == 0">No address available</h4>
    </div>
</template>

<script>
    import { mapGetters } from 'vuex'

    export default {
        name: 'Profile',
        data() {
            return {
            }
        },
        mounted() {
            this.$store.dispatch('address/getOtherUserAddresses', this.$route.params.user_id)
            this.$store.dispatch('user/getOtherUser', this.$route.params.user_id)
        },
        computed: {
            ...mapGetters('user', {
                other_user: 'getOtherUser',
            }),
            ...mapGetters('address', {
                other_user_addresses: 'getOtherUserAddresses',
            }),
            ...mapGetters('auth', {
                loggedUser: 'getUser',
            }),
        }
    }
</script>